# Computed foreign keys

{% hint style="success" %}
This is the official documentation of the `forestadmin/laravel-forestadmin` v2+ and `forestadmin/symfony-forestadmin` PHP agents.
{% endhint %}

You may want to create a relationship between 2 Collections, but you don't have a foreign key that is ready to use to connect them.

To solve that use case, you should use both [computed fields](/developer-guide-agents-php/agent-customization/fields/computed.md) and relationships.

This is done with the following steps:

* create a new Field containing a foreign key,
* make the Field filterable for the `In` operator (see [Under the hood](/developer-guide-agents-php/agent-customization/relationships/under-the-hood.md) as to why this is required),
* create a relation using it.

### Displaying a link to the last message sent by a customer

We have 2 Collections: `Customers` and `Messages`, linked together by a `one-to-many` relationship.

We want to create a `ManyToOne` relationship with the last message sent by a given customer.

```php
use ForestAdmin\AgentPHP\DatasourceCustomizer\CollectionCustomizer;
use ForestAdmin\AgentPHP\DatasourceCustomizer\Decorators\Computed\ComputedDefinition;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\Operators;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Aggregation;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\Filter;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\PaginatedFilter;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\ConditionTreeFactory;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Projection\Projection;

$forestAgent->customizeCollection(
    'Customer',
    function (CollectionCustomizer $builder) {
        // Create foreign key
        $builder->addField(
            'lastMessageId',
            new ComputedDefinition(
                columnType: 'Number',
                dependencies: ['id'],
                values: function ($customers, $context) {
                	$customerIds = array_map(fn ($r) => $r['id'], $customers);

                    // We're using Forest Admin's query interface
                    $filter = new Filter(
                        conditionTree: ConditionTreeFactory::fromArray(
                            ['field' => 'customer_id', 'operator' => 'In', 'value' => $customerIds]
                        )
                    );
                    $aggregation = new Aggregation(operation: 'Max', field: 'id', groups: [[ 'field' =>'customer_id' ]]);
                    $rows = $context->getDatasource()->getCollection('Message')->aggregate($filter, $aggregation);

                    return array_map(
                        function ($customer) use ($rows) {
                            foreach ($rows as $row) {
                                if ($row['group']['customer_id'] === $customer['id']) {
                                    return $row['value'] ?? null;
                                }
                            }

                            return 0;
                        },
                        $customers
                    );
                }
            )
        )->replaceFieldOperator(
            'lastMessageId',
            'In',
            function ($lastMessageIds, $context) {
                $filter = new PaginatedFilter(
                        conditionTree: ConditionTreeFactory::fromArray(
                            ['field' => 'id', 'operator' => 'In', 'value' => $lastMessageIds]
                        )
                    );
                $records = $context->getDatasource()
                    ->getCollection('Message')
                    ->list($filter, new Projection(['customer_id']));

                return ['field' => 'id', 'operator' => 'In', 'value' => array_map(fn ($r) => $r['customer_id'], $records)];
            }
        )->addManyToOneRelation('lastMessage', 'Message', 'lastMessageId');
    }
);
```

### Connecting collections without having a shared identifier

You have 2 Collections and both contain users: one comes from your database, and the other one is connected to the CRM that your company uses.

There is no common id between them that can be used to tell Forest Admin how to link them together, however, both Collections have `firstName`, `lastName`, and `birthDate` fields, which taken together, are unique enough.

```php
use ForestAdmin\AgentPHP\DatasourceCustomizer\CollectionCustomizer;
use ForestAdmin\AgentPHP\DatasourceCustomizer\Decorators\Computed\ComputedDefinition;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\Operators;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Aggregation;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\Filter;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\PaginatedFilter;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\ConditionTreeFactory;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Projection\Projection;

/**
 * Concatenate firstname, lastname and birthData to make a unique identifier
 * and ensure that the new field is filterable
 */
$createFilterableIdentityField = function (CollectionCustomizer $collection) {
    // Create foreign key on the collection from the database
    $collection->addField(
        'userIdentifier',
        new ComputedDefinition(
            columnType: 'String',
            dependencies: ['firstName', 'lastName', 'birthDate'],
            values: fn($users) => array_map(fn($u) => $u['firstName'] .'/'. $u['lastName'] .'/'. $u['birthDate'] , $users),
        )
    );

  // Implement 'In' filtering operator (required)
  $collection->replaceFieldOperator(
      'userIdentifier',
      Operators::IN,
      fn ($values) => [
          'aggregator' => 'Or',
          'conditions' => array_map(
              fn ($value) => [
                  'aggregator' => 'And',
                  'conditions' => [
                      ['field' => 'firstName', 'operator' => Operators::EQUAL, explode('/', $value)[0]],
                      ['field' => 'lastName', 'operator' => Operators::EQUAL, explode('/', $value)[1]],
                      ['field' => 'birthDate', 'operator' => Operators::EQUAL, explode('/', $value)[2]],
                  ]
              ]
          ),
      ]
  );
};

/** Create relationship between databaseUsers and crmUsers */
$createRelationship = function (CollectionCustomizer $collection) {
    $collection->addOneToOneRelation(
        name: 'userFromCrm',
        foreignCollection: 'crmUsers',
        originKey: 'userIdentifier',
        originKeyTarget: 'userIdentifier',
    );
};

/** Create relationship between crmUsers and databaseUsers */
$createInverseRelationship = function (CollectionCustomizer $collection) {
    $collection->addManyToOneRelation(
        name: 'userFromDatabase',
        foreignCollection: 'databaseUsers',
        foreignKey: 'userIdentifier',
        foreignKeyTarget: 'userIdentifier',
    );
};

$forestAgent->customizeCollection('databaseUsers', $createFilterableIdentityField)
    ->customizeCollection('crmUsers', $createFilterableIdentityField)
    ->customizeCollection('databaseUsers', $createRelationship)
    ->customizeCollection('crmUsers', $createInverseRelationship);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-php/agent-customization/relationships/computed-fks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
